package com.tzld.piaoquan.recommend.model.service.model;


import com.tzld.piaoquan.recommend.model.util.CompressUtil;
import com.tzld.piaoquan.recommend.model.util.PropertiesUtil;
import org.apache.commons.lang.math.NumberUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Map;


public class DSSMModel extends Model {
    private static final Logger LOGGER = LoggerFactory.getLogger(DSSMModel.class);

private Predictor predictor;
    @Override
    public boolean loadFromStream(InputStreamReader in) throws Exception {
        return false;
    }

    public void cleanModel() {
        this.model = null;
    }

    public Float infer() {

        try {
            float[] values = new float[features.length];
            for (int i = 0; i < features.length; i++) {
                float v = NumberUtils.toFloat(featureMap.getOrDefault(features[i], "0.0"), 0.0f);
                values[i] = v;
            }
            DMatrix dm = new DMatrix(values, 1, features.length, 0.0f);
            float[][] result = model._booster().predict(dm, false, 100);
            return result[0][0];
        } catch (Exception e) {
            return 0f;
        }
    }

    @Override
    public boolean loadFromStream(InputStream in) throws Exception {
        String modelDir = PropertiesUtil.getString("model.xgboost.path");
        CompressUtil.decompressGzFile(in, modelDir);
        this.model = model2;
        return true;
    }

}
